﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using System.Collections;

namespace CustomSorting
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            Data = new ObservableCollection<DataItem>()
            {
                new DataItem
                {
                    Title = "A",
                    Child = new ObservableCollection<ChildDataItem>()
                    {
                        new ChildDataItem { Value = 50},
                        new ChildDataItem { Value = 75},
                        new ChildDataItem { Value = 10},
                    }
                },

                new DataItem
                {
                    Title = "B",
                    Child = new ObservableCollection<ChildDataItem>()
                    {
                        new ChildDataItem { Value = -7},
                        new ChildDataItem { Value = -2},
                        new ChildDataItem { Value = -9},
                    }
                }
            };

            DataContext = this;
        }

        public ObservableCollection<DataItem> Data { get; set; }
    }

    public class DataItem
    {
        public string Title { get; set; }
        public ObservableCollection<ChildDataItem> Child { get; set; }
    }

    public class ChildDataItem
    {
        public int Value { get; set; }
    }

    public class Comparer : IComparer
    {
        public int Compare(object x, object y)
        {
            if (Math.Abs((int)x) == Math.Abs((int)y))
                return 0;

            if (Math.Abs((int)x) > Math.Abs((int)y))
                return 1;

            if (Math.Abs((int)x) < Math.Abs((int)y))
                return -1;

            return -1;
        }
    }

}
